import { DocumentNode } from 'graphql';
import { ApolloQueryResult } from 'apollo-client';
import { Observable } from 'rxjs';
import { Apollo } from './Apollo';
import { QueryRef } from './QueryRef';
import { WatchQueryOptions, QueryOptions, R } from './types';
export declare class Query<T = {}, V = R> {
    protected apollo: Apollo;
    readonly document: DocumentNode;
    client: string;
    constructor(apollo: Apollo);
    watch(variables?: V, options?: WatchQueryOptions<V>): QueryRef<T, V>;
    fetch(variables?: V, options?: QueryOptions<V>): Observable<ApolloQueryResult<T>>;
}
